﻿Imports System.Web.UI

Partial Public Class MyLabel
    Inherits System.Web.UI.UserControl

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    Protected Overrides Sub Render(ByVal writer As HtmlTextWriter)

        writer.Write("<div")
        If _cssClass IsNot "" Then
            writer.Write(" class=""")
            writer.Write(_cssClass)
            writer.Write("""")
        End If
        If _style IsNot "" Then
            writer.Write(" style=""")
            writer.Write(_style)
            writer.Write("""")
        End If
        writer.Write(">")
        writer.Write(text)
        writer.Write("</div>")

    End Sub

    ' <summary>
    ' UserControl.SaveViewState override.
    ' </summary>
    Protected Overrides Function SaveViewState() As Object

        Dim map As System.Collections.Hashtable = New System.Collections.Hashtable()

        map.Add("Text", _text)
        map.Add("Style", _style)
        map.Add("CssClass", _cssClass)

        Return map

    End Function

    ' <summary>
    ' UserControl.LoadViewState override.
    ' </summary>
    Protected Overrides Sub LoadViewState(ByVal savedState As Object)

        Dim map As System.Collections.Hashtable = CType(savedState, System.Collections.Hashtable)

        If map Is Nothing Then
            Return
        End If

        _text = CType(map("Text"), String)
        _style = CType(map("Style"), String)
        _cssClass = CType(map("CssClass"), String)

    End Sub


    ' <summary>
    ' UserControl.AddParsedSubObject override.
    ' </summary>
    Protected Overrides Sub AddParsedSubObject(ByVal obj As Object)

        If TypeOf obj Is LiteralControl Then
            text = CType(obj, LiteralControl).Text
        End If

        Me.AddParsedSubObject(obj)

    End Sub

    Property Text() As String
        Get
            Return _text
        End Get
        Set(ByVal value As String)
            _text = value
        End Set
    End Property

    ' <summary>
    ' Gets or sets the css clas associated with the label.
    ' </summary>
    Property CssClass() As String

        Get
            Return _cssClass
        End Get
        Set(ByVal value As String)
            _cssClass = value
        End Set

    End Property

    ' <summary>
    ' Gets or sets the css style of the label.
    ' </summary>
    Property Style() As String

        Get
            Return _style
        End Get
        Set(ByVal value As String)
            _style = value
        End Set

    End Property


    Dim _text As String
    Dim _cssClass As String
    Dim _style As String

End Class